import { insertLinkWithMultilinkUpdate } from '../store/modules/data.store.js'
import { sample, random } from 'lodash'

export function generateDataset(nodeCount, linkCount) {
  const nodes = [], links = []

  for (let n = 0; n < nodeCount; n++) {
    nodes.push({
      id: n,
      name: getSampleFirstName() + ' Chalupová-Tročkova',
      dataClass: 'person',
      type: 'regular',
      label: getSampleFirstName(),
      vis: { graph: { x: 0, y: 0 }}
    })
  }
  const lastNodeId = nodeCount - 1

  let sourceId = 0, targetId = lastNodeId
  for (let n = 0; n < linkCount; n++) {
    let link = {
      id: n,
      source: sourceId,
      target: targetId,
      direction: random(0, 100) < 40,
      description: getSampleLinkDescription()
    }
    if (insertLinkWithMultilinkUpdate(link, links, n + 1)) n++

    if (random(0, 100) < 50) sourceId++
    if (random(0, 100) < 50) targetId--
    if (sourceId === targetId) sourceId++
    if (sourceId > lastNodeId || targetId > lastNodeId || targetId < 0) break
  }

  sourceId = 0, targetId = lastNodeId
  for (let n = linkCount + 1; n < linkCount + 50; n++) {
    let link = {
      id: n,
      source: sourceId,
      target: targetId,
      direction: random(0, 100) < 60,
      description: getSampleLinkDescription()
    }
    if (insertLinkWithMultilinkUpdate(link, links, n + 1)) n++

    if (random(0, 100) < 50) sourceId += random(0, 4)
    if (random(0, 100) < 30) targetId += random(0, 4)
    if (sourceId === targetId) sourceId++
    if (sourceId > lastNodeId || targetId > lastNodeId || targetId < 0) break
  }

  return { nodes: nodes, links: links }
}

function getSampleFirstName() {
  return sample([
    'Anna',
    'Alexandra',
    'Daniela',
    'Čestmír',
    'Anton',
    'Igor',
    'Katarína',
    'Vincent',
    'Lívia',
    'Miloslava',
    'Mikuláš',
    'David',
    'Henrieta',
    'Ema',
    'Irena'
  ])
}

function getSampleLinkDescription() {
  return sample([
    'killed',
    'teaches',
    'used',
    'friend',
    'spouse',
    'family',
    'business connections',
    'lived together',
    'transferred money to'
  ])
}
